/**********************************************************************
 
	Copyright (C) 2007- Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/



#ifndef ___FA_CACHE_H___
#define ___FA_CACHE_H___

#include "machine/include.h"
#include "avt.h"


#define FAC_SIZE		4096
#define FAC_DEFAULT_ENTRIES	((128*1024*1024)/FAC_SIZE)
#define FAC_DIRTY_RATE		0.75

typedef struct fac_entry_header {
	struct fac_entry_header *	next;
	struct fac_entry_header *	prev;
} FAC_ENTRY_HEADER;

typedef struct fac_entry {
	FAC_ENTRY_HEADER	h;
	unsigned		dirty:1;
	U_INTEGER64		offset;
	U_INTEGER64		access_time;
	U_INTEGER64		create_time;
	int			len;
	char *			data;
} FAC_ENTRY;

typedef struct fac_info {
	FAC_ENTRY_HEADER	entries;
	FAC_ENTRY_HEADER*	clean_point;
	U_INTEGER64		seek_point;
	U_INTEGER64		file_size;
	int			entries_nos;
	int			dirty_nos;
	int			total_entries;
	AVT_NODE *		entries_tree;
	int			interval;

/* init is required */
	int			fd;
	unsigned		long_file:1;
} FAC_INFO;


#endif

